/**
 * 
 */
package org.elsys.pluginsample.editor.undoredo;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.action.Action;

/**
 * @author kiko
 * 
 */
public class AddAction extends Action {

	private UndoableListEditor fEditor;

	public AddAction(UndoableListEditor editor) {
		super();
		setText("Add");
		fEditor = editor;
	}

	@Override
	public void run() {
		AddOperation operation = new AddOperation(fEditor);
		operation.addContext(fEditor.getUndoContext());
		IProgressMonitor monitor = fEditor.getEditorSite().getActionBars()
				.getStatusLineManager().getProgressMonitor();

		try {
			fEditor.getOperationHistory().execute(operation, monitor, null);
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
	}

}
