/**
 * 
 */
package org.elsys.pluginsample.editor.undoredo;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;

/**
 * @author kiko
 * 
 */
public class DeleteAction extends Action {

	private UndoableListEditor fEditor;

	public DeleteAction(UndoableListEditor editor) {
		super();
		setText("Delete");
		fEditor = editor;
		fEditor.getViewer().addSelectionChangedListener(
				new ISelectionChangedListener() {

					public void selectionChanged(SelectionChangedEvent event) {
						if (((IStructuredSelection) fEditor.getViewer()
								.getSelection()).isEmpty() == false) {
							setEnabled(true);
						} else
							setEnabled(false);
					}

				});
	}

	@Override
	public void run() {
		DeleteOperation op = new DeleteOperation(fEditor);
		op.addContext(fEditor.getUndoContext());
		IProgressMonitor monitor = fEditor.getEditorSite().getActionBars()
				.getStatusLineManager().getProgressMonitor();
		try {
			fEditor.getOperationHistory().execute(op, monitor, null);
		} catch (ExecutionException e) {
			e.printStackTrace();
		}
	}
}
