/**
 * 
 */
package org.elsys.pluginsample.editor.undoredo;

import org.eclipse.core.commands.operations.IOperationHistory;
import org.eclipse.core.commands.operations.IUndoContext;
import org.eclipse.core.commands.operations.OperationHistoryFactory;
import org.eclipse.core.commands.operations.UndoContext;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.operations.RedoActionHandler;
import org.eclipse.ui.operations.UndoActionHandler;

/**
 * @author kiko
 * 
 */
public class UndoableListEditor extends ListEditor {

	private IUndoContext fUndoContext;

	private IOperationHistory fOperationHistory;

	private UndoActionHandler fUndoActionHandler;

	private RedoActionHandler fRedoActionHandler;

	public IUndoContext getUndoContext() {
		return fUndoContext;
	}

	public IOperationHistory getOperationHistory() {
		return fOperationHistory;
	}

	@Override
	public void init(IEditorSite site, IEditorInput input)
			throws PartInitException {
		super.init(site, input);
		fOperationHistory = OperationHistoryFactory.getOperationHistory();
	}

	@Override
	protected void fillContextMenu(IMenuManager menuMgr) {
		menuMgr.add(fUndoActionHandler);
		menuMgr.add(fRedoActionHandler);
		super.fillContextMenu(menuMgr);
	}

}
